/*
Copyright  2008 Brent Boyer

This program is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the Lesser GNU General Public License for more details.

You should have received a copy of the Lesser GNU General Public License along with this program (see the license directory in this project).  If not, see <http://www.gnu.org/licenses/>.
*/


/**
* For the article <a href="http://www.ibm.com/developerworks/java/library/j-benchmark1.html">Robust Java benchmarking, Part 1: Issues</a>,
* contains the code relevant to <a href="http://www.ibm.com/developerworks/java/library/j-benchmark1.html#listing1">Listing 1</a>.
* <p>
* @author Brent Boyer
*/
public class N01_Part1_Listing1 {
	
	
	/** Global variable. */
	protected static int global;
	
	
	/**
	* Results on 2008/3/27 on my 2.2 GHz Intel Core 2 Duo E4500 machine (server jvm):
	* <pre><code>
		a): Execution time: 34.539226 milliseconds
		b): Execution time: 52.472849 milliseconds
		c): Execution time: 35.368021999999996 milliseconds
		d): Execution time: 35.024231 milliseconds
	</code></pre>
	*/
	public static void main(String[] args) throws Exception {
		System.out.println();
		System.out.println("N01_Part1_Listing1:");
		
		long t1 = System.nanoTime();
		
		int value = 0;
		for (int i = 0; i < 100 * 1000 * 1000; i++) {
			value = calculate(value);
		}
		
		long t2 = System.nanoTime();
		System.out.println("Execution time: " + ((t2 - t1) * 1e-6) + " milliseconds");
	}
	
	
	/** Performs some simple calculations. */
	protected static int calculate(int arg) {
		//L1: assert (arg >= 0) : "should be positive";
		//L2: if (arg < 0) throw new IllegalArgumentException("arg = " + arg + " < 0");
		
		global = arg * 6;
		global += 3;
		global /= 2;
		return arg + 2;
	}
	
	
}