/*
Copyright  2008 Brent Boyer

This program is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the Lesser GNU General Public License for more details.

You should have received a copy of the Lesser GNU General Public License along with this program (see the license directory in this project).  If not, see <http://www.gnu.org/licenses/>.
*/


/**
* For the article <a href="http://www.ibm.com/developerworks/java/library/j-benchmark1.html">Robust Java benchmarking, Part 1: Issues</a>,
* contains the code relevant to <a href="http://www.ibm.com/developerworks/java/library/j-benchmark1.html#listing7">Listing 7</a>.
* <p>
* @author Brent Boyer
*/
public class N05_Part1_Listing7 {
	
	
	/**
	* Results on 2008/3/27 on my 2.2 GHz Intel Core 2 Duo E4500 machine (server jvm):
	* <pre><code>
		Execution time = 10.81... seconds to compute result = 1580674560
		Execution time = 10.79... seconds to compute result = 1580674560
		Execution time = 10.80... seconds to compute result = 1580674560
	</code></pre>
	*/
	public static void main(String[] args) {
		System.out.println();
		System.out.println("N05_Part1_Listing7:");
		
		long t1 = System.nanoTime();
		
		int result = 0;
		for (int i = 0; i < 1000 * 1000; i++) {	// sole loop
			result += sum();
		}
		
		long t2 = System.nanoTime();
		System.out.println("Execution time: " + ((t2 - t1) * 1e-9) + " seconds to compute result = " + result);	// use this line to get expected execution time
		//System.out.println("Execution time: " + ((t2 - t1) * 1e-9) + " seconds to compute result");	// use this line to get reduced execution time because of DCE
	}
	
	
	protected static int sum() {
		int sum = 0;
		for (int j = 0; j < 10 * 1000; j++) {
			sum += j;
		}
		return sum;
	}
	
	
}