/*
Copyright  2008 Brent Boyer

This program is free software: you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the Lesser GNU General Public License for more details.

You should have received a copy of the Lesser GNU General Public License along with this program (see the license directory in this project).  If not, see <http://www.gnu.org/licenses/>.
*/


import bb.util.Benchmark;


/**
* For the <a href="http://www.ellipticgroup.com/html/benchmarkingArticle.html">article supplement</a>,
* contains the code relevant to Listing 1 and Listing 2.
* <p>
* @author Brent Boyer
*/
public class N10_Supplement_Lfsr {
	
	
	/**
	* Results on 2008/3/27 on my 2.2 GHz Intel Core 2 Duo E4500 machine (server jvm):
	* <pre><code>
		run #1:	mean = 1.031 s (CI deltas: -394.666 us, +423.214 us), sd = 1.650 ms (CI deltas: -221.499 us, +368.772 us)
		run #2:	mean = 1.030 s (CI deltas: -260.489 us, +281.354 us), sd = 1.087 ms (CI deltas: -136.216 us, +206.500 us)
		run #3:	mean = 1.031 s (CI deltas: -247.205 us, +259.635 us), sd = 1.019 ms (CI deltas: -141.767 us, +188.889 us)
	</code></pre>
	*/
	public static void main(String[] args) throws Exception {
		System.out.println();
		System.out.println("N10_Supplement_Lfsr:");
		
		Runnable task = new Benchmark.LfsrAdvancer();	// Lfsr is actually defined inside Benchmark because it is used to measure noise floors
		System.out.println("Benchmark.LfsrAdvancer: " + (new Benchmark(task).getStatsBlock().toString()));
	}
	
	
}